/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.mangue.client.select;

import java.awt.BorderLayout;
import java.awt.Color;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableCellRenderer;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.mangue.common.modele.interfaces.INomenclature;
import org.cocktail.mangue.common.modele.nomenclatures.contrat.EOTypeContratTravail;
import org.cocktail.mangue.common.utilities.CocktailIcones;
import org.cocktail.application.client.tools.CocktailUtilities;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class TypeContratTravailSelectView extends javax.swing.JDialog {

	private static final long serialVersionUID = 75089577772567331L;
	protected EODisplayGroup eod1, eod2;
	protected ZEOTable myEOTable1, myEOTable2;
	protected ZEOTableModel myTableModel2, myTableModel3;
	protected TableSorter myTableSorter2, myTableSorter3;
	private ZEOTableCellRenderer myRenderer;

    
    /** Creates new form TemplateJDialog */
    public TypeContratTravailSelectView(java.awt.Frame parent, boolean modal, EODisplayGroup eod2, 
    		EODisplayGroup eod3, ZEOTableCellRenderer myRenderer) {
        super(parent, modal);

        this.eod1 = eod2;
        this.eod2 = eod3;
        this.myRenderer = myRenderer;

        initComponents();
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        viewTableNiveau2 = new javax.swing.JPanel();
        btnAnnuler = new javax.swing.JButton();
        btnValider = new javax.swing.JButton();
        checkTous = new javax.swing.JRadioButton();
        checkNonEns = new javax.swing.JRadioButton();
        checkEns = new javax.swing.JRadioButton();
        checkHu = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        tfFiltreLibelleNiveau1 = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        popupTitulaire = new javax.swing.JComboBox();
        viewTableNiveau3 = new javax.swing.JPanel();
        tfFiltreLibelleNiveau2 = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Sélection Types de Crédit");

        viewTableNiveau2.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewTableNiveau2.setLayout(new java.awt.BorderLayout());

        btnAnnuler.setToolTipText("Annuler");

        btnValider.setToolTipText("Valider la sélection");
        btnValider.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValiderActionPerformed(evt);
            }
        });

        buttonGroup1.add(checkTous);
        checkTous.setText("TOUS");

        buttonGroup1.add(checkNonEns);
        checkNonEns.setText("Non Enseignants");

        buttonGroup1.add(checkEns);
        checkEns.setText("Enseignants");

        buttonGroup1.add(checkHu);
        checkHu.setSelected(true);
        checkHu.setText("H.U.");

        jLabel1.setText("Recherche ?");

        tfFiltreLibelleNiveau1.setText("jTextField1");

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("titulaire ?");

        popupTitulaire.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        viewTableNiveau3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewTableNiveau3.setLayout(new java.awt.BorderLayout());

        tfFiltreLibelleNiveau2.setText("jTextField1");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(checkTous)
                        .add(18, 18, 18)
                        .add(checkNonEns)
                        .add(10, 10, 10)
                        .add(checkEns)
                        .add(10, 10, 10)
                        .add(checkHu)
                        .add(18, 18, 18)
                        .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 63, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(popupTitulaire, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 115, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(btnAnnuler, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnValider, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(viewTableNiveau2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 459, Short.MAX_VALUE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                            .add(layout.createSequentialGroup()
                                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 75, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(tfFiltreLibelleNiveau1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(296, 296, 296)))
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(tfFiltreLibelleNiveau2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, viewTableNiveau3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 466, Short.MAX_VALUE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(checkTous)
                    .add(checkNonEns)
                    .add(checkEns)
                    .add(checkHu)
                    .add(jLabel2)
                    .add(popupTitulaire, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(tfFiltreLibelleNiveau1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel1)
                    .add(tfFiltreLibelleNiveau2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTableNiveau3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 545, Short.MAX_VALUE)
                    .add(viewTableNiveau2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 545, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(btnValider, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnAnnuler, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-967)/2, (screenSize.height-690)/2, 967, 690);
    }// </editor-fold>//GEN-END:initComponents

    private void btnValiderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValiderActionPerformed
    }//GEN-LAST:event_btnValiderActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                TypeContratTravailSelectView dialog = new TypeContratTravailSelectView(new javax.swing.JFrame(), true, null, null, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAnnuler;
    private javax.swing.JButton btnValider;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JRadioButton checkEns;
    private javax.swing.JRadioButton checkHu;
    private javax.swing.JRadioButton checkNonEns;
    private javax.swing.JRadioButton checkTous;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JComboBox popupTitulaire;
    private javax.swing.JTextField tfFiltreLibelleNiveau1;
    private javax.swing.JTextField tfFiltreLibelleNiveau2;
    private javax.swing.JPanel viewTableNiveau2;
    private javax.swing.JPanel viewTableNiveau3;
    // End of variables declaration//GEN-END:variables

	private void initGui() {
        
		setTitle("Sélection d'un Type de Contrat");		
    	
    	btnValider.setIcon(CocktailIcones.ICON_VALID);
        btnAnnuler.setIcon(CocktailIcones.ICON_CANCEL);
        
        CocktailUtilities.initPopupOuiNon(popupTitulaire, true);
                
        checkTous.setSelected(true);
        
		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

    	ZEOTableModelColumn	col = new ZEOTableModelColumn(eod1, INomenclature.CODE_KEY, "Code", 50);
    	col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod1, INomenclature.LIBELLE_LONG_KEY, "Libellé", 250);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);

		myTableModel2 = new ZEOTableModel(eod1, myCols);
		myTableSorter2 = new TableSorter(myTableModel2);

		myEOTable1 = new ZEOTable(myTableSorter2);
		myTableSorter2.setTableHeader(myEOTable1.getTableHeader());		

		myEOTable1.setBackground(new Color(230, 230, 230));
		myEOTable1.setSelectionBackground(new Color(127,155,165));
		myEOTable1.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableNiveau2.setLayout(new BorderLayout());
		viewTableNiveau2.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableNiveau2.removeAll();
		viewTableNiveau2.add(new JScrollPane(myEOTable1), BorderLayout.CENTER);

		
		myCols = new Vector<ZEOTableModelColumn>();

    	col = new ZEOTableModelColumn(eod2, INomenclature.CODE_KEY, "Code", 50);
    	col.setAlignment(SwingConstants.CENTER);
		//col.setTableCellRenderer(myRenderer);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod2, INomenclature.LIBELLE_LONG_KEY, "Libellé", 300);
    	col.setAlignment(SwingConstants.LEFT);
		//col.setTableCellRenderer(myRenderer);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod2, EOTypeContratTravail.TEM_LOCAL_KEY, "Local", 75);
    	col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);

		myTableModel3 = new ZEOTableModel(eod2, myCols);
		myTableSorter3 = new TableSorter(myTableModel3);

		myEOTable2 = new ZEOTable(myTableSorter3);
		myTableSorter3.setTableHeader(myEOTable2.getTableHeader());		

		myEOTable2.setBackground(new Color(230, 230, 230));
		myEOTable2.setSelectionBackground(new Color(127,155,165));
		myEOTable2.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableNiveau3.setLayout(new BorderLayout());
		viewTableNiveau3.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableNiveau3.removeAll();
		viewTableNiveau3.add(new JScrollPane(myEOTable2), BorderLayout.CENTER);

		
    }
	public javax.swing.JButton getBtnAnnuler() {
		return btnAnnuler;
	}

	public void setBtnAnnuler(javax.swing.JButton btnAnnuler) {
		this.btnAnnuler = btnAnnuler;
	}

	public javax.swing.JButton getBtnValider() {
		return btnValider;
	}

	public void setBtnValider(javax.swing.JButton btnValider) {
		this.btnValider = btnValider;
	}

	public javax.swing.JRadioButton getCheckEns() {
		return checkEns;
	}

	public void setCheckEns(javax.swing.JRadioButton checkEns) {
		this.checkEns = checkEns;
	}

	public javax.swing.JRadioButton getCheckHu() {
		return checkHu;
	}

	public void setCheckHu(javax.swing.JRadioButton checkHu) {
		this.checkHu = checkHu;
	}

	public javax.swing.JRadioButton getCheckNonEns() {
		return checkNonEns;
	}

	public void setCheckNonEns(javax.swing.JRadioButton checkNonEns) {
		this.checkNonEns = checkNonEns;
	}

	public javax.swing.JRadioButton getCheckTous() {
		return checkTous;
	}

	public void setCheckTous(javax.swing.JRadioButton checkTous) {
		this.checkTous = checkTous;
	}

	public javax.swing.JComboBox getPopupTitulaire() {
		return popupTitulaire;
	}

	public void setPopupTitulaire(javax.swing.JComboBox popupTitulaire) {
		this.popupTitulaire = popupTitulaire;
	}

	public ZEOTable getMyEOTable1() {
		return myEOTable1;
	}

	public void setMyEOTable1(ZEOTable myEOTable1) {
		this.myEOTable1 = myEOTable1;
	}

	public ZEOTable getMyEOTable2() {
		return myEOTable2;
	}

	public void setMyEOTable2(ZEOTable myEOTable2) {
		this.myEOTable2 = myEOTable2;
	}

	public javax.swing.JTextField getTfFiltreLibelleNiveau1() {
		return tfFiltreLibelleNiveau1;
	}

	public void setTfFiltreLibelleNiveau1(
			javax.swing.JTextField tfFiltreLibelleNiveau1) {
		this.tfFiltreLibelleNiveau1 = tfFiltreLibelleNiveau1;
	}

	public javax.swing.JTextField getTfFiltreLibelleNiveau2() {
		return tfFiltreLibelleNiveau2;
	}

	public void setTfFiltreLibelleNiveau2(
			javax.swing.JTextField tfFiltreLibelleNiveau2) {
		this.tfFiltreLibelleNiveau2 = tfFiltreLibelleNiveau2;
	}
	
}
